<template>
<!-- 国贸计划审核 -->
    <div class="outElectricity">
        <div class="box">
            <div class="box-top">
                <el-form
                    style="overflow: hidden;"
                    :style="filterForm.show ? null : { height: '0px' }"
                    size="mini"
                    label-width="75px"
                >
                    <el-row>
                        <el-col :span="6">
                            <el-form-item label="排产日期">
                                <zj-timegran-date
                                    v-model="filterForm.data.time"
                                    style="width: 100%;"
                                    :type="'daterange'"
                                    :oneFoo="getTableData"
                                    :custom ="1"
                                ></zj-timegran-date>
                            </el-form-item>
                        </el-col>
                        <el-col :span="4">
                           <el-form-item label="编号">
                                    <el-input
                                    v-model="filterForm.data.id"
                                    style="width: 100%;"
                                    refcous="true"
                                    ></el-input>
                            </el-form-item>
                        </el-col>
                        <el-col :span="4">
                            <el-form-item label="工序">
                            <el-select
                            filterable clearable
                            collapse-tags
                            v-model="filterForm.data.workprocType"
                            multiple
                            placeholder=""
                            style="width: 100%;"
                            >
                            <el-option
                            v-for="item of nameObj.workprocid.arr"
                            :key="item.id"
                            :value="item.id"
                            :label="item.name"
                            ></el-option>
                            </el-select>
                            </el-form-item>
                        </el-col>
                        <el-col :span="4">
                            <el-form-item label="状态">
                            <el-select
                            filterable
                            collapse-tags
                            v-model="filterForm.data.state"
                            multiple
                            placeholder=""
                            style="width: 100%;"
                            >
                            <el-option
                            v-for="item of nameObj.state.arr"
                            :key="item.id"
                            :value="item.id"
                            :label="item.name"
                            ></el-option>
                            </el-select>
                            </el-form-item>
                        </el-col>
                    </el-row>
                </el-form>
                <div class="box-top-gjl">
                    <el-form size="mini" label-width="75px">
                        <el-row>
                            <el-col :span="16">
                                <el-button
                                     type="primary"
                                     size="mini"
                                     icon="el-icon-add-outline"
                                    @click="passaudits()"
                                    :loading="loading"
                                >审核下发</el-button>
                                 <el-button
                                     size="mini"
                                     type="danger"
                                     icon="el-icon-add-outline"
                                    @click="turndown()"
                                    :loading="loading"
                                >取消下发</el-button>
                            </el-col>
                            <el-col :span="8">
                                <div style="float:right; text-align: right;">
                                    <el-button
                                        class="button"
                                        type="primary"
                                        size="mini"
                                        icon="el-icon-search"
                                        v-if="butPrivilege.QUERY"
                                        @click="getTableData()"
                                    >查询</el-button>
                                    <el-button
                                        size="mini"
                                        :icon="filterForm.show ? 'el-icon-caret-top' : 'el-icon-caret-bottom'"
                                        :title="filterForm.show ? '收起搜索区' : '展开搜索区'"
                                        @click="filterForm.show = !filterForm.show;
                                            $nextTick(() => {
                                                singleTableHeight = getRoleHeight($refs['singleTable'].$el) - 45;
                                            }
                                        );"
                                    >{{ filterForm.show ? '收起' : '展开' }}</el-button>
                                </div>
                            </el-col>
                        </el-row>
                    </el-form>
                </div>
            </div>
            <div class="box-bottom">
                <el-form
                    size="mini"
                    ref="dialog_form_arr"
                    label-width="0px"
                    :model="tableFormDataObj"
                >
                    <el-table
                        stripe
                        id="singleTable"
                        ref="singleTable"
                        :data="tableData"
                        v-loading="tableLoading"
                        style="width: 100%;"
                        :height="singleTableHeight"
                        border
                        size="mini"
                        highlight-current-row
                        @selection-change="handleSelectionChange"
                        :summary-method="getSummaries"
                        :row-class-name="tableRowClassName"
                        @cell-click="cellClick"
                        @expand-change="rowClick"
                    >
                        <el-table-column
                            type="selection"
                            width="40"
                            align="center"
                            fixed="left"
                            class-name="cnspicuous"
                        ></el-table-column>
                        <el-table-column
                           sortable
                            prop="id"
                            label="编号"
                            align="center"
                            fixed="left"
                            width="120px"
                            :show-overflow-tooltip="true"
                        ></el-table-column>
                        <el-table-column
                            sortable
                            prop="workprocType"
                            label="工序"
                            align="center"
                            fixed="left"
                            width="120px"
                            :show-overflow-tooltip="true"
                        >
                        <template slot-scope="scope">
                              <span>{{ nameObj.workprocid.obj[scope.row.workprocType] ? nameObj.workprocid.obj[scope.row.workprocType].name : scope.row.workprocType }}</span>
                        </template>
                        </el-table-column>
                        <el-table-column
                           sortable
                            prop="jhTime"
                            label="排产日期"
                            align="center"
                            fixed="left"
                            width="88px"
                            :show-overflow-tooltip="true"
                        ></el-table-column>
                        <el-table-column
                           sortable
                            prop="deliveryDate"
                            label="交货日期"
                            align="center"
                            fixed="left"
                            width="88px"
                            :show-overflow-tooltip="true"
                        ></el-table-column>
                        <el-table-column
                           sortable
                            prop="state"
                            label="状态"
                            align="center"
                            fixed="left"
                            width="88px"
                            :show-overflow-tooltip="true"
                        >
                        <template slot-scope="scope">
                                <span
                                    :style="{color: nameObj.state.obj[scope.row.state] ? nameObj.state.obj[scope.row.state].color : ''}"
                                >{{ nameObj.state.obj[scope.row.state] ? nameObj.state.obj[scope.row.state].name : scope.row.state }}</span>
                        </template>
                        </el-table-column>
                        <el-table-column
                        sortable
                            prop="tag"
                            label="订单类型"
                            align="center"
                            fixed="left"
                            width="88px"
                            :show-overflow-tooltip="true"
                        >
                         <template slot-scope="scope">
                                <span
                                    :style="{color: nameObj.tag.obj[scope.row.tag] ? nameObj.tag.obj[scope.row.tag].color : ''}"
                                >{{ nameObj.tag.obj[scope.row.tag] ? nameObj.tag.obj[scope.row.tag].name : scope.row.tag }}</span>
                        </template>
                        </el-table-column>
                        <el-table-column
                           sortable
                            prop="grades"
                            label="钢种"
                            align="center"
                            fixed="left"
                            width="106px"
                            :show-overflow-tooltip="true"
                        >
                        </el-table-column>
                        <el-table-column
                           sortable
                            prop="specifications"
                            label="规格"
                            align="center"
                            fixed="left"
                            width="105px"
                            :show-overflow-tooltip="true"
                            v-if="filterForm.data.gx!='XG'"
                        >
                        </el-table-column>
                        <el-table-column
                            sortable
                            prop="lengths"
                            label="长度"
                            align="center"
                            width="80px"
                            :show-overflow-tooltip="true"
                        >
                        </el-table-column>
                        <!-- <el-table-column
                            sortable
                            prop="lengthTimesWidth"
                            label="高度*宽度"
                            align="center"
                            width="120px"
                            :show-overflow-tooltip="true"
                        >
                        </el-table-column> -->
                        <el-table-column
                            sortable
                            prop="planWeight"
                            label="计划量"
                            align="center"
                            width="60px"
                            :show-overflow-tooltip="true"
                        >
                        </el-table-column>
                        <el-table-column
                            sortable
                            prop="transportType"
                            label="运输方式"
                            align="center"
                            width="87px"
                            :show-overflow-tooltip="true"
                        >
                        </el-table-column>
                        <el-table-column
                            sortable
                            prop="purpose"
                            label="用途"
                            align="center"
                            width="87px"
                            :show-overflow-tooltip="true"
                        >
                        </el-table-column>
                        <el-table-column
                            sortable
                            prop="gmReviewer"
                            label="审核人"
                            align="center"
                            min-width="120px"
                            :show-overflow-tooltip="true"
                        >
                        </el-table-column>
                         <el-table-column
                             sortable
                            prop="gmReviewerTime"
                            label="审核时间"
                            align="center"
                            width="120px"
                            :show-overflow-tooltip="true"
                        >
                        </el-table-column>
                        <el-table-column
                            sortable
                            prop="createMan"
                            label="创建人"
                            align="center"
                            width="120px"
                            :show-overflow-tooltip="true"
                        >
                        </el-table-column>
                         <el-table-column
                             sortable
                            prop="createTime"
                            label="创建时间"
                            align="center"
                            width="120px"
                            :show-overflow-tooltip="true"
                        >
                        </el-table-column>
                    </el-table>
                </el-form>
                <el-pagination
                    layout="total, sizes, prev, pager, next, jumper"
                    :total="total"
                    :page-sizes="[10, 20, 50, 100, 500, 1000]"
                    :page-size="pageSize"
                    :current-page.sync="pageNum"
                    @size-change="tableSizeChange"
                    @current-change="getTableData()"
                    style="text-align: right;margin-top: 10px;"
                ></el-pagination>
            </div>
        </div>
    </div>
</template>
<script>
import { zCheckNumber1 } from '~/utils/validator.js';
import timegranDate from '~/components/zg/timegranDate.vue';
import {formatDate, XtcommonSummaries, getCookie} from '@/utils/util.js';
import store from '@/store/index.js';
export default {
    name: 'outElectricity',
    components: {
        'zj-timegran-date': timegranDate
    },
    data () {
        let setDate = new Date();
        setDate.setDate(15);
        setDate.setMonth((setDate.getMonth() - 1));
        return {
            rowIndex: '',
            columnId: '',
            focusTarget: null,
            seqArr: [],
            editSetFlag: '',
            isCheck: false, // 是否为审核人
            isClick: false,
            filterForm: {
                show: true,
                data: {
                    show: false,
                    id: '',
                    workprocType: [],
                    state: ['1'],
                    time: [(new Date() - 3600 * 1000 * 24 * 7), (new Date() + 3600 * 1000 * 24 * 7)]
                },
                rules: {
                },
                disabled: {
                    networkid: false
                }
            },
            pageNum: 1,
            pageSize: 100,
            total: 0,
            singleTableHeight: 100,
            tableData: [
            ],
            expands: {},
            loading: false,
            tableLoading: false,
            multipleSelection: [],
            tableFormDataObj: {},
            nameObj: {
                state: {
                    obj: {
                        '1': {
                            name: '等待审核',
                            color: '#7a7a7a'
                        },
                        '2': {
                            name: '已下发',
                            color: 'green'
                        },
                        '3': {
                            name: '已接收',
                            color: 'red'
                        }
                    },
                    arr: [
                        {
                            id: '1',
                            name: '等待审核',
                            color: '#7a7a7a'
                        },
                        {
                            id: '2',
                            name: '已下发',
                            color: 'green'
                        },
                        {
                            id: '3',
                            name: '已接收',
                            color: 'red'
                        }
                    ]
                },
                roleList: {
                    obj: {},
                    arr: []
                },
                type: {
                    obj: {
                        '0': '否',
                        '1': '是'
                    },
                    arr: [
                        {
                            id: '0',
                            name: '否'
                        },
                        {
                            id: '1',
                            name: '是'
                        }
                    ]
                },
                 transportType: {
                    obj: {'0': {name: '火运'}, '1': {name: '汽运'}, '2': {name: '汽运或者火运'}},
                    arr: [
                        {
                            id: '0',
                            name: '火运'
                        },
                        {
                            id: '1',
                            name: '汽运'
                        },
                        {
                            id: '2',
                            name: '汽运或者火运'
                        }
                    ]
                },
                workprocid: {
                    obj: {'AT2004': {name: '炼钢'}, 'AT2005': {name: '一高线'}, 'AT2006': {name: '二高线'}, 'AT2007': {name: '型钢'}},
                    arr: [
                        {
                         id: 'AT2004',
                         name: '炼钢'
                        },
                        {
                         id: 'AT2005',
                         name: '一高线'
                        },
                        {
                         id: 'AT2006',
                         name: '二高线'
                        },
                        {
                         id: 'AT2007',
                         name: '型钢'
                        }
                        ]
                },
                location: {
                    obj: {},
                    arr: [],
                    showDataArr: []
                },
                purpose: {
                    obj: {
                        '0': {name: '标准件'},
                        '1': {name: '铁丝'},
                        '2': {name: '钢丝、弹簧'}
                    },
                    arr: [
                        {
                            id: '0',
                            name: '标准件'
                        },
                        {
                            id: '1',
                            name: '铁丝'
                        },
                        {
                            id: '2',
                            name: '钢丝、弹簧'
                        }
                    ]
                },
                locateid: {
                    obj: {},
                    arr: []
                },
                networkid: {
                    obj: {},
                    arr: []
                },
                userId: {
                    obj: {},
                    arr: []
                },
                unitid: {
                    obj: {},
                    arr: [],
                    defaults: ''
                },
                 grades: {
                    obj: {},
                    arr: []
                },
                specifications: {
                    obj: {},
                    arr: []
                },
                lengthTimeswidth: {
                    obj: {},
                    arr: []
                },
                chemicalStandard: {
                    obj: {},
                    arr: []
                },
                tag: {
                    obj: {
                        '0': {
                            name: '正常',
                            color: '#7a7a7a'
                        },
                        '1': {
                            name: '应急',
                            color: 'red'
                        }
                    },
                    arr: [
                        {
                            id: '0',
                            name: '正常'
                        },
                        {
                            id: '1',
                            name: '应急'
                        }
                    ]
                }
            },
            butPrivilege: {
                QUERY: false,
                PUT: false,
                CHECK: false,
                UNDOCHECK: false
            },
            loginName: getCookie('loginName'),
            userInfo: {},
            userRoles: {},
            qrRole: [],
            spread: false,
            store
        }
    },
    created () {
        // 获取按钮权限
        this.activeMenu = window.localStorage.getItem('activeMenu');
        for (let key in this.butPrivilege) {
            this.butPrivilege[key] = this.checkPrivilege(this.activeMenu + key);
        }
    },
    mounted () {
        let that = this;
        window.PEDataObj = {
            // 将数据绑定到window上，供main页面使用
            vm: that,
            // tableArr：用于导出成Excel的表格的信息
            tableArr: [
                {
                    name: '',
                    id: 'singleTable'
                }
            ]
        };
        that.$nextTick(() => {
            // 立即获取的height有一定偏差，通过setTimeout延迟来解决
            setTimeout(() => {
                that.singleTableHeight = that.getRoleHeight(that.$refs['singleTable'].$el) - 45;
            }, 1);
        });
        // 接收路由参数
        if (that.$route.query.workproc_type) {
            that.filterForm.data.workproc_type = that.$route.query.workproc_type;
        }
        // 当有审核与取消审核权限时，默认其为审核人，审核人无法修改数据
        if (that.butPrivilege.CHECK || that.butPrivilege.UNDOCHECK) {
            that.isCheck = true;
        }
        // 管理员在这里录入数据
        if (that.loginName === 'admin' && that.filterForm.disabled.networkid) {
            that.isCheck = false;
        }
        // 接收路由参数
        if (that.$route.query.gx) {
            that.filterForm.data.gx = that.$route.query.gx;
            let its = that.filterForm.data.gx.split(',');
            if (its && its.length > 10) {
                that.pageSize = 50;
                that.custom = 0;
            }
        }
        that.getUnitIdData();
        // that.getlengthTimesWidth();
        that.getRoles();
    },
    methods: {
        //  计算树区域高度
        getRoleHeight (dom) {
            return window.innerHeight - dom.offsetTop;
        },
        // 自定义的表格合计方法：只给指定列进行合计
        getSummaries (param) {
            const prop = ['planWeight']; // 合计列绑定的prop
            return XtcommonSummaries(param, prop);
        },
        rowClick (row) {
          let that = this,
            params = {
                parentid: row.id
            };
            that.tableLoading = true;
            let url = 'pass/ems/v1/emsprodplanrounds/getRounds';
            that.axios.get(url, {
                params: params
            })
                .then(function (res) {
                    if (res.code === '0') {
                        let chirItem = Object.keys(res.data[0])[0];
                        that.expands[chirItem] = res.data[0][chirItem];
                    } else {
                        that.$message.error(res.message);
                    }
                    that.tableLoading = false;
                }).catch(function () {
                    that.tableLoading = false;
                });
        },
        // 获取高线钢种
        getGrades () {
            let that = this
            let type = '';
            if (that.filterForm.data.gx === 'GX') {
               type = '高线'
            }
            if (that.filterForm.data.gx === 'XG') {
               type = '型钢'
            }
            let url = 'pass/product/v1/emssteel/getGrades/?type=' + type;
            that.axios.get(url)
                .then(function (res) {
                    if (res.code === '0') {
                        let arr = [];
                        let obj = {};
                        for (let item of res.data) {
                            arr.push({
                                id: item.id,
                                name: item.steelName
                            })
                                obj[item.id] = {
                                name: item.steelName,
                                id: item.id
                            }
                        }
                        that.nameObj.grades.arr = arr;
                        that.nameObj.grades.obj = obj;
                    } else {
                        that.$message.error(res.message);
                    }
                });
        },
        // 获取高线规格
        getSpecifications () {
            let that = this
            let url = 'pass/product/v1/emssteel/getSpecifications/?type=' + '高线';
            that.axios.get(url)
                .then(function (res) {
                    if (res.code === '0') {
                        let arr = [];
                        let obj = {};
                        for (let item of res.data) {
                            arr.push({
                                id: item.id,
                                name: item.specName
                            })
                            obj[item.id] = {
                                name: item.specName,
                                unitid: item.id
                            }
                        }
                        that.nameObj.specifications.arr = arr;
                        that.nameObj.specifications.obj = obj;
                    } else {
                        that.$message.error(res.message);
                    }
                });
        },
        // 获取高线执行标准
         getStandards () {
             let that = this
            let url = 'pass/product/v1/emsstandard/getStandards';
            that.axios.get(url)
                .then(function (res) {
                    if (res.code === '0') {
                        let arr = [];
                        let obj = {};
                        for (let item of res.data) {
                            arr.push({
                                id: item.basecode,
                                name: item.basename
                            })
                        }
                        that.nameObj.chemicalStandard.arr = arr;
                        that.nameObj.chemicalStandard.obj = obj;
                    } else {
                        that.$message.error(res.message);
                    }
                });
        },
        // 获取炼钢钢种
        getGradesASLg () {
            let that = this
            let url = 'pass/product/v1/emsvqcmbasesteel/getBase'
            that.axios.get(url)
                .then(function (res) {
                    if (res.code === '0') {
                        let arr = [];
                        let obj = {};
                        for (let item of res.data) {
                            arr.push({
                                id: item.id,
                                name: item.name
                            })
                            obj[item.id] = {
                                name: item.name,
                                id: item.id
                            }
                        }
                        that.nameObj.grades.arr = arr;
                        that.nameObj.grades.obj = obj;
                    } else {
                        that.$message.error(res.message);
                    }
                });
        },
        // 获取炼钢规格
        getSpecificationsAsLg () {
            let that = this
            let url = 'pass/product/v1/emsvqcmbasespecbillet/getbasespecbillet';
            that.axios.get(url)
                .then(function (res) {
                    if (res.code === '0') {
                        let arr = [];
                        let obj = {};
                        for (let item of res.data) {
                            arr.push({
                                id: item.id,
                                name: item.name
                            })
                            obj[item.id] = {
                                name: item.name,
                                id: item.id
                            }
                        }
                        that.nameObj.specifications.arr = arr;
                        that.nameObj.specifications.obj = obj;
                    } else {
                        that.$message.error(res.message);
                    }
                });
        },
        // 获取炼钢化学成分标准
        getStandardsAsLg () {
            let that = this
            let url = 'pass/product/v1/emsvqcmstdchem/getstdchem';
            that.axios.get(url)
                .then(function (res) {
                    if (res.code === '0') {
                        let arr = [];
                        let obj = {};
                        for (let item of res.data) {
                            arr.push({
                                id: item.basecode,
                                name: item.standardgb
                            })
                        }
                        that.nameObj.chemicalStandard.arr = arr;
                        that.nameObj.chemicalStandard.obj = obj;
                    } else {
                        that.$message.error(res.message);
                    }
                });
        },
        // 获取型钢宽度*长度
        // getlengthTimesWidth () {
        //     let that = this
        //     let url = 'pass/ems/v1/emsprodplanrounds/getbasespecbillet';
        //     that.axios.get(url)
        //         .then(function (res) {
        //             if (res.code === '0') {
        //                 let arr = [];
        //                 let obj = {};
        //                 for (let item of res.data) {
        //                     arr.push({
        //                         id: item.id,
        //                         name: item.specifications
        //                     })
        //                 }
        //                 that.nameObj.specifications.arr = arr;
        //                 that.nameObj.specifications.obj = obj;
        //             } else {
        //                 that.$message.error(res.message);
        //             }
        //         });
        // },
        connn () {
            let that = this;
            if (!that.filterForm.data.networkid || that.filterForm.data.networkid.length === 0) {
                that.nameObj.location.showDataArr = that.nameObj.workprocid.arr;
            } else {
                let url = 'pass/ems/v1/emsprodplanmonths/getWorkprocs'
                that.axios.get(url)
                    .then(function (res) {
                        if (res.code === '0') {
                            let arr = [];
                            for (let item of res.data) {
                                arr.push({
                                    id: item.id,
                                    name: item.name
                                })
                            }
                            that.nameObj.location.showDataArr = arr;
                        } else {
                            that.$message.error(res.message);
                        }
                    });
            }
        },
        // 保存数据
        dataSave () {
            let that = this;
            let SubmitData = {
                jhTime: that.dialog.editorBox.form.data.jhTime,
                grades: that.dialog.editorBox.form.data.grades,
                unitid: '008',
                chemicalStandard: that.dialog.editorBox.form.data.chemicalStandard,
                planWeight: that.dialog.editorBox.form.data.planWeight,
                specifications: that.dialog.editorBox.form.data.specifications,
                transportType: that.dialog.editorBox.form.data.transportType,
                memo: that.dialog.editorBox.form.data.memo,
                workprocType: that.filterForm.data.workproc_type,
                lengths: that.dialog.editorBox.form.data.lengths,
                purpose: that.dialog.editorBox.form.data.purpose,
                iateralArea: that.dialog.editorBox.form.data.iateralArea,
                deliveryDate: that.dialog.editorBox.form.data.deliveryDate,
                lengthTimesWidth: that.dialog.editorBox.form.data.lengthTimesWidth,
                dimension: that.dialog.editorBox.form.data.dimension,
                surfaceStandard: that.dialog.editorBox.form.data.surfaceStandard,
                state: '0'
            };
            that.$refs['dialog_form'].validate((valid) => {
               if (valid) {
                        that.loading = true;
                        that.axios.post('pass/ems/v1/emsgmpcjhs/', SubmitData, {
                            contentType: 'application/json'
                        })
                            .then(function (res) {
                                if (res.code === '0') {
                                    that.$message({
                                        message: '新增成功',
                                        type: 'success'
                                    });
                                    that.getTableData();
                                    that.dialog.editorBox.show = false;
                                } else {
                                    that.$message.error(res.message);
                                }
                                that.loading = false;
                            }).catch(function () {
                                that.loading = false;
                            });
                }
            });
        },
        // 获取表格中的数据
        getTableData (pageNum) {
            let that = this,
            params = {},
                pData = {
                   startTime: that.filterForm.data.time[0],
                   endTime: that.filterForm.data.time[1],
                   id: that.filterForm.data.id,
                   workprocType: that.filterForm.data.workprocType.toString(),
                   state: that.filterForm.data.state.toString() === '' ? '1,2,3,4' : that.filterForm.data.state.toString()
                };
                for (let key in pData) {
                    if (pData[key]) {
                        params[key] = pData[key];
                    }
                }
            that.pageNum = pageNum || that.pageNum;
            that.tableLoading = true;
            let url = 'pass/ems/v1/emsgmpcjhs/getShData/?pageNum=' + that.pageNum + '&pageSize=' + that.pageSize;
            that.axios.get(url, {
                params: params
            })
                .then(function (res) {
                    if (res.code === '0') {
                        let arr = [];
                        for (let i = 0; i < res.data.list.length; i++) {
                            let item = res.data.list[i];
                            arr.push({
                                seq: i,
                                id: item.id,
                                jhTime: item.jhTime,
                                deliveryDate: item.deliveryDate,
                                state: item.state,
                                unitid: item.unitid,
                                grades: item.grades,
                                specifications: item.specifications,
                                lengths: item.lengths,
                                lengthTimesWidth: item.lengthTimesWidth,
                                transportType: item.transportType,
                                purpose: item.purpose,
                                workprocType: item.workprocType,
                                createMan: item.createMan,
                                createTime: item.createTime,
                                planWeight: item.planWeight,
                                gmReviewer: item.gmReviewer,
                                gmReviewerTime: item.gmReviewerTime,
                                tag: item.tag ? item.tag : '0'
                            });
                        }
                        that.total = res.data.total;
                        that.tableData = arr;
                        that.getAdds();
                    } else {
                        that.$message.error(res.message);
                    }
                    that.$nextTick(() => {
                        setTimeout(() => {
                            that.singleTableHeight = that.getRoleHeight(that.$refs['singleTable'].$el) - 46;
                        }, 1);
                    });
                    that.tableLoading = false;
                }).catch(function () {
                    that.tableLoading = false;
                });
        },
        // 改变表格显示条数
        tableSizeChange (val) {
            let that = this;
            that.pageSize = val;
            that.getTableData(1);
        },
        keyDown (event1, disabledFlag) {
            let tdTarget = event1.target;
            let _this = this;
            while (tdTarget.tagName !== 'TD') {
                tdTarget = tdTarget.parentElement;
            }
            // 如果按下键盘下键或者回车键
            if (event.keyCode === 40 || event.keyCode === 13) {
                let index = parseInt(this.rowIndex);
                // index++;
                if (index !== this.seqArr[this.seqArr.length - 1]) {
                    for (let i = 0; i < this.seqArr.length; i++) {
                        if (index === this.seqArr[i]) {
                        index = this.seqArr[i + 1];
                        break;
                        }
                    }
                }
                this.editSetFlag = index + this.columnId;
                let id = '#' + this.editSetFlag;
                this.$nextTick(() => {
                    $(id).click();
                });
            } else if (event.keyCode === 38) { // 键盘上键
                let index = parseInt(this.rowIndex);
                if (index !== this.seqArr[0]) {
                    for (let i = 0; i < this.seqArr.length; i++) {
                        if (index === this.seqArr[i]) {
                        index = this.seqArr[i - 1];
                        break;
                        }
                    }
                }
                this.editSetFlag = index + this.columnId;
                let id = '#' + this.editSetFlag;
                this.$nextTick(() => {
                    $(id).click();
                });
            } else if (event.keyCode === 37) { // 键盘左键
                $(tdTarget).prevAll().find('input:text').last().click();
            } else if (event.keyCode === 39) { // 键盘右键
                $(tdTarget).nextAll().find('input').eq(0).click();
            }
        },
        // 只允许对未接受的数据进行操作
        checkboxT (row, index) {
          if (row.state === '3' && !this.isCheck) {
                return false;
            } else {
                return true;
            }
        },
        // 获取标准计量单位
        getUnitIdData () {
            let that = this
            let url = 'pass/ems/v1/trmunits/getIdAndName';
            that.axios.get(url)
                .then(function (res) {
                    if (res.code === '0') {
                        let arr = [];
                        let obj = {};
                        for (let item of res.data) {
                            arr.push({
                                id: item.id,
                                name: item.name
                            })
                            obj[item.id] = item.name;
                            if (item.name === '吨') {
                                that.nameObj.unitid.defaults = that.nameObj.unitid.defaults ? that.nameObj.unitid.defaults : item.id;
                            }
                        }
                        that.nameObj.unitid.arr = arr;
                        that.nameObj.unitid.obj = obj;
                    } else {
                        that.$message.error(res.message);
                    }
                });
        },
        handleSelectionChange (val) {
            let that = this;
            let tableFormDataObj = {};
            let arr = [];
            for (let item of val) {
                arr.push(item.seq);
            }
            this.seqArr = arr.sort(sortNumber);
            for (let item of that.tableData) {
                item.isSelection = false;
            }
            for (let item of val) {
                let obj = {};
                let xId = item.seq;
                if (that.tableFormDataObj[xId]) {
                    // 如果已存在该数据则使用该数据
                    tableFormDataObj[xId] = that.tableFormDataObj[xId];
                } else {
                    // 负责则从对应行中获取行内原数据
                    for (let key in item) {
                        obj[key] = item[key];
                    }
                    item.realvalue = (!isNaN(Number(item.apportvalue)) && !isNaN(Number(item.wastage))) ? Number(item.apportvalue) + Number(item.wastage) - Number(item.secondVal) : item.realvalue;
                    tableFormDataObj[xId] = obj;
                }
                item.isSelection = true;
            }
            for (let item of that.tableData) {
                if (item.isSelection === false) {
                    item.realvalue = (!isNaN(Number(item.apportvalue)) && !isNaN(Number(item.wastage))) ? Number(item.apportvalue) + Number(item.wastage) - Number(item.secondVal) : item.realvalue;
                }
            }
            that.tableFormDataObj = tableFormDataObj;
            that.multipleSelection = val;
            this.getAdds();
        },
        handleclickChange (row, column, cell, event) {
            let that = this;
            if (column.label === '计划量' && !this.isClick) {
                 that.isClick = true;
            } else {
                 that.isClick = false;
            }
        },
        getApportValue (seq, value, rowIndex, event) {
            let that = this;
            if (!isNaN(Number(value))) {
                if (!isNaN(Number(that.tableFormDataObj[seq].mintvalue)) && !isNaN(Number(that.tableFormDataObj[seq].mendvalue)) && that.tableFormDataObj[seq].mintvalue !== null && that.tableFormDataObj[seq].mendvalue !== null) {
                    let poor = that.floatComputed(Number(that.tableFormDataObj[seq].mendvalue), Number(that.tableFormDataObj[seq].mintvalue), '-');
                    that.tableFormDataObj[seq].apportvalue = that.floatComputed(poor, Number(that.tableFormDataObj[seq].mods), '*').toFixed(0);
                    let rv1 = that.floatComputed(Number(that.tableFormDataObj[seq].apportvalue), Number(that.tableFormDataObj[seq].wastage), '+');
                    that.tableFormDataObj[seq].realvalue = that.floatComputed(rv1, Number(that.tableFormDataObj[seq].secondVal), '-').toFixed(0);
                    that.showRealValue(rowIndex, that.tableFormDataObj[seq].realvalue);
                }
            }
        },
        // 手动修改抄度后计算实际电量
        chnageApportvalue (seq, value, rowIndex) {
            let that = this;
            if (!isNaN(Number(value)) && !isNaN(Number(that.tableFormDataObj[seq].wastage))) {
                that.tableFormDataObj[seq].realvalue = that.floatComputed(Number(value), Number(that.tableFormDataObj[seq].wastage), '+').toFixed(0);
            }
            that.showRealValue(rowIndex, that.tableFormDataObj[seq].realvalue);
        },
        // 手动修改损耗后计算实际电量
        chnageWastage (seq, value, rowIndex) {
            let that = this;
            if (!isNaN(Number(value)) && !isNaN(Number(that.tableFormDataObj[seq].apportvalue)) && that.tableFormDataObj[seq].apportvalue !== null) {
                let rv1 = that.floatComputed(Number(value), Number(that.tableFormDataObj[seq].apportvalue), '+');
                that.tableFormDataObj[seq].realvalue = that.floatComputed(rv1, Number(that.tableFormDataObj[seq].secondVal), '-').toFixed(0);
                that.showRealValue(rowIndex, that.tableFormDataObj[seq].realvalue);
            }
        },
        // 手动修改二次转供电后计算实际电量
        chnageSecondVal (seq, value, rowIndex) {
            let that = this;
            if (!isNaN(Number(value)) && !isNaN(Number(that.tableFormDataObj[seq].apportvalue)) && that.tableFormDataObj[seq].apportvalue !== null) {
                let val1 = that.floatComputed(Number(that.tableFormDataObj[seq].apportvalue), Number(that.tableFormDataObj[seq].wastage), '+');
                that.tableFormDataObj[seq].realvalue = that.floatComputed(val1, Number(value), '-').toFixed(0);
                that.showRealValue(rowIndex, that.tableFormDataObj[seq].realvalue);
            }
        },
        // 统计合计值
        getAdds () {
            let that = this;
            let wlarr = [];
            for (var i = 0; i < that.tableData.length; i++) {
               wlarr.push(that.tableData[i].workprocid + '-' + that.tableData[i].location + '-' + that.tableData[i].workshop + '-' + that.tableData[i].clock + '-' + that.tableData[i].clocke);
            }
            let wls = [...new Set(wlarr)]
            let arrs = [];
            for (let wl of wls) {
                let rxj = 0;
                let yhj = 0;
                for (let item of that.tableData) {
                    if (wl === item.workprocid + '-' + item.location + '-' + item.workshop + '-' + item.clock + '-' + item.clocke) {
                        rxj = that.floatComputed(Number(item.weightDay), rxj, '+');
                        yhj = that.floatComputed(Number(item.weightMonth), yhj, '+');
                    }
                }
                for (let i = 0; i < that.tableData.length; i++) {
                    if (wl === that.tableData[i].workprocid + '-' + that.tableData[i].location + '-' + that.tableData[i].workshop + '-' + that.tableData[i].clock + '-' + that.tableData[i].clocke) {
                        that.tableData[i].rxj = rxj;
                        that.tableData[i].yhj = yhj;
                    }
                }
            }
        },
        // 展示实际电量
        showRealValue (rowIndex, value) {
            let that = this;
            for (let i = 0; i < that.tableData.length; i++) {
                if (i === rowIndex) {
                    that.tableData[i].realvalue = value;
                }
            }
            this.getAdds();
        },
        // 批量修改
        but_edit_plural () {
            let that = this;
            if (that.multipleSelection.length > 0) {
                that.$refs['dialog_form_arr'].validate((valid, obj) => {
                    if (valid) {
                        let SubmitData = [];
                        for (let key in that.tableFormDataObj) {
                            SubmitData.push({
                                id: that.tableFormDataObj[key].id,
                                jhTime: that.tableFormDataObj[key].jhTime,
                                grades: that.tableFormDataObj[key].grades,
                                transportType: that.tableFormDataObj[key].transportType,
                                specifications: that.tableFormDataObj[key].specifications,
                                unitid: that.tableFormDataObj[key].unitid,
                                memo: that.tableFormDataObj[key].memo,
                                workprocType: that.filterForm.data.workproc_type,
                                chemicalStandard: that.tableFormDataObj[key].chemicalStandard,
                                planWeight: that.tableFormDataObj[key].planweight,
                                createTime: that.tableFormDataObj[key].createtime,
                                purpose: that.tableFormDataObj[key].purpose,
                                createMan: that.tableFormDataObj[key].createman,
                                updateTime: that.tableFormDataObj[key].updatetime,
                                updateMan: that.tableFormDataObj[key].updateman,
                                state: that.tableFormDataObj[key].state,
                                lengths: that.tableFormDataObj[key].lengths,
                                surfaceStandard: that.tableFormDataObj[key].surfacestandard,
                                deliveryDate: that.tableFormDataObj[key].deliveryDate,
                                dimension: that.tableFormDataObj[key].dimension,
                                iateralArea: that.tableFormDataObj[key].iateralarea,
                                lengthTimesWidth: that.tableFormDataObj[key].lengthtimeswidth
                            });
                        }
                        that.loading = true;
                        that.axios.put('pass/ems/v1/emsgmpcjhs/batchupdate', SubmitData)
                            .then(function (res) {
                                if (res.code === '0') {
                                    that.$message({
                                        message: '修改成功',
                                        type: 'success'
                                    });
                                    that.getTableData();
                                    that.dialog.editorBox.show = false;
                                } else {
                                    that.$message.error(res.message);
                                }
                                that.loading = false;
                            }).catch(function () {
                                that.loading = false;
                            });
                        }
                });
            } else {
                this.$message.error('至少要选择一条数据');
            }
        },
        getRoles () {
            let that = this;
            // 获取用户信息
            this.store.dispatch('getUserInfo').then((res) => {
                this.userInfo = res.data;
                that.axios.get('pass/v1/sysuserroles/?userId=' + res.data.userId + '&pageNum=1&pageSize=100').then(rest => {
                  if (rest) {
                    for (let i = 0; i < rest.data.list.length; i++) {
                      that.qrRole.push(rest.data.list[i].roleId)
                    }
                    that.userRoles = rest.data.list; // 获取用户角色关联信息
                  }
          let roleId = this.nameObj.roleList.obj['生产部-生产处'].id;
                if (this.qrRole.includes(roleId)) {
                this.spread = true;
           }
        })
            });
            // 获取角色信息
            this.store.dispatch('system/rolesManage/list').then(res => {
              if (res.code === '0') {
                this.nameObj.roleList.arr = res.data;
                for (let obj of res.data) {
                    this.nameObj.roleList.obj[obj.roleName] = {
                        name: obj.roleName,
                        id: obj.id
                    };
                }
                } else {
              this.$message.error(res.message);
            }
            });
        },
        turndown () {
            let that = this;
            if (that.multipleSelection.length > 0) {
                that.$refs['dialog_form_arr'].validate((valid, obj) => {
                    if (valid) {
                        let SubmitData = [];
                        for (let key in that.tableFormDataObj) {
                            SubmitData.push({
                                id: that.tableFormDataObj[key].id,
                                workprocType: that.filterForm.data.workproc_type,
                                state: '0'
                            });
                        }
                        that.loading = true;
                        that.axios.put('pass/ems/v1/emsgmpcjhs/turndown', SubmitData)
                            .then(function (res) {
                                if (res.code === '0') {
                                    that.$message({
                                        message: '操作成功',
                                        type: 'success'
                                    });
                                    that.getTableData();
                                    that.dialog.editorBox.show = false;
                                } else {
                                    that.$message.error(res.message);
                                }
                                that.loading = false;
                            }).catch(function () {
                                that.loading = false;
                            });
                        }
                });
            } else {
                this.$message.error('至少要选择一条数据');
            }
        },
        passaudits () {
            let that = this;
            if (that.multipleSelection.length > 0) {
                that.$refs['dialog_form_arr'].validate((valid, obj) => {
                    if (valid) {
                        let SubmitData = [];
                        for (let key in that.tableFormDataObj) {
                            SubmitData.push({
                                id: that.tableFormDataObj[key].id,
                                workprocType: that.filterForm.data.workproc_type,
                                state: '2'
                            });
                        }
                        that.loading = true;
                        that.axios.put('pass/ems/v1/emsgmpcjhs/passaudits', SubmitData)
                            .then(function (res) {
                                if (res.code === '0') {
                                    that.$message({
                                        message: '操作成功',
                                        type: 'success'
                                    });
                                    that.getTableData();
                                    that.dialog.editorBox.show = false;
                                } else {
                                    that.$message.error(res.message);
                                }
                                that.loading = false;
                            }).catch(function () {
                                that.loading = false;
                            });
                        }
                });
            } else {
                this.$message.error('至少要选择一条数据');
            }
        },
        // 下发
         issue (state) {
            let that = this;
            if (that.multipleSelection.length > 0) {
                that.$refs['dialog_form_arr'].validate((valid, obj) => {
                    if (valid) {
                        let SubmitData = [];
                        for (let key in that.tableFormDataObj) {
                            SubmitData.push({
                                id: that.tableFormDataObj[key].id,
                                workprocType: that.filterForm.data.workproc_type,
                                state: state
                            });
                        }
                        that.loading = true;
                        that.axios.put('pass/ems/v1/emsgmpcjhs/updatestate', SubmitData)
                            .then(function (res) {
                                if (res.code === '0') {
                                    that.$message({
                                        message: '修改成功',
                                        type: 'success'
                                    });
                                    that.getTableData();
                                    that.dialog.editorBox.show = false;
                                } else {
                                    that.$message.error(res.message);
                                }
                                that.loading = false;
                            }).catch(function () {
                                that.loading = false;
                            });
                        }
                });
            } else {
                this.$message.error('至少要选择一条数据');
            }
        },
        // 批量删除
        but_del_plural () {
            let that = this;
            if (that.multipleSelection.length > 0) {
                let SubmitData = [];
                for (let item of that.multipleSelection) {
                    SubmitData.push({
                        id: item.id,
                        state: item.state,
                        sqno: item.sqno
                    });
                }
                that.$confirm('是否删除已选数据?', '提示', {
                    confirmButtonText: '确定',
                    cancelButtonText: '取消',
                    state: 'warning'
                }).then(() => {
                    that.axios.delete('pass/ems/v1/emsgmpcjhs/delete', {
                        data: SubmitData,
                        contentType: 'application/json;charset=UTF-8'
                    })
                        .then(function (res) {
                            if (res.code === '0') {
                                that.$message({
                                    message: '删除成功',
                                    type: 'success'
                                });
                                that.getTableData();
                            } else {
                                that.$message.error(res.message);
                            }
                        }).catch(function () {
                        });
                }).catch(() => {
                });
            } else {
                this.$message.error('至少要选择一条数据');
            }
        },
        tableRowClassName ({row, rowIndex}) {
            // 把每一行的索引放进row
            row.index = rowIndex;
        },
        cellClick (row, column, cell, event) {
            let _this = this;
            this.rowIndex = row.index;
            this.columnId = column.id;
            _this.editSetFlag = row.index + column.id;
            _this.focusTarget = event.target;
            while (_this.focusTarget.tagName !== 'TD') {
                _this.focusTarget = _this.focusTarget.parentElement;
            }
            _this.$nextTick(() => {
                let target = this.focusTarget;
                $(target).find('input').focus();
            });
        }
    }
}
function sortNumber (a, b) {
  return a - b
}
</script>

<style lang="less">
.outElectricity{
    min-width: 700px;
    height: 100%;
    .box {
        height: 100%;
        padding: 15px 15px 0 15px;
        .box-top {
            .el-form-item {
                margin-bottom: 7px;
            }
            .box-top-gjl {
                overflow: hidden;
                padding: 7px 0;
                border-top: 1px solid #ccc;
            }
        }
        .rowDisable td {
            color: #6bb025 !important;
        }
        .el-table .el-table__row {
            height: 35px;
        }
        .el-table__body .el-form-item--mini.el-form-item {
            margin: 0px;
            .error {
                overflow: hidden;
                color: #f56c6c;
                font-size: 12px;
                line-height: 1;
            }
        }
    }
    .color_no {
        color: #7a7a7a;
    }
    .color_yes {
        color: #1a9f17;
    }
    .cnspicuous .el-checkbox__input.is-disabled .el-checkbox__inner {
        background-color: #dcdfe6;
        border-color: #babbbf;
    }
}
</style>
